/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     |
    \\  /    A nd           | www.openfoam.com
     \\/     M anipulation  |
-------------------------------------------------------------------------------
    Copyright (C) 2011-2016 OpenFOAM Foundation
    Copyright (C) 2019-2021 OpenCFD Ltd.
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

// * * * * * * * * * * * * * * * * Selectors * * * * * * * * * * * * * * * * //

template<class Type>
Foam::tmp<Foam::fvPatchgpuField<Type>> Foam::fvPatchgpuField<Type>::New
(
    const word& patchFieldType,
    const word& actualPatchType,
    const gpufvPatch& p,
    const DimensionedgpuField<Type, gpuvolMesh>& iF
)
{
    DebugInFunction
        << "patchFieldType = " << patchFieldType
        << " : " << p.type() << nl;

    auto* ctorPtr = patchConstructorTable(patchFieldType);

    if (!ctorPtr)
    {
        FatalErrorInLookup
        (
            "patchField",
            patchFieldType,
            *patchConstructorTablePtr_
        ) << exit(FatalError);
    }

    auto* patchTypeCtor = patchConstructorTable(p.type());

    if
    (
        actualPatchType == word::null
     || actualPatchType != p.type()
    )
    {
        if (patchTypeCtor)
        {
            return patchTypeCtor(p, iF);
        }
        else
        {
            return ctorPtr(p, iF);
        }
    }


    tmp<fvPatchgpuField<Type>> tfvp = ctorPtr(p, iF);

    // Check if constraint type override and store patchType if so
    if (patchTypeCtor)
    {
        tfvp.ref().patchType() = actualPatchType;
    }
    return tfvp;
}


template<class Type>
Foam::tmp<Foam::fvPatchgpuField<Type>> Foam::fvPatchgpuField<Type>::New
(
    const word& patchFieldType,
    const gpufvPatch& p,
    const DimensionedgpuField<Type, gpuvolMesh>& iF
)
{
    return New(patchFieldType, word::null, p, iF);
}


template<class Type>
Foam::tmp<Foam::fvPatchgpuField<Type>> Foam::fvPatchgpuField<Type>::New
(
    const gpufvPatch& p,
    const DimensionedgpuField<Type, gpuvolMesh>& iF,
    const dictionary& dict
)
{
    const word patchFieldType(dict.get<word>("type"));

    DebugInFunction
        << "patchFieldType = " << patchFieldType << nl;

    auto* ctorPtr = dictionaryConstructorTable(patchFieldType);

    if (!ctorPtr)
    {
        if (!disallowGenericFvPatchgpuField)
        {
            ctorPtr = dictionaryConstructorTable("generic");
        }

        if (!ctorPtr)
        {
            FatalIOErrorInFunction(dict)
                << "Unknown patchField type " << patchFieldType
                << " for patch type " << p.type() << nl << nl
                << "Valid patchField types :" << endl
                << dictionaryConstructorTablePtr_->sortedToc()
                << exit(FatalIOError);
        }
    }

    if
    (
        !dict.found("patchType")
     || dict.get<word>("patchType") != p.type()
    )
    {
        auto* patchTypeCtor = dictionaryConstructorTable(p.type());

        if (patchTypeCtor && patchTypeCtor != ctorPtr)
        {
            FatalIOErrorInFunction(dict)
                << "inconsistent patch and patchField types for\n"
                   "    patch type " << p.type()
                << " and patchField type " << patchFieldType
                << exit(FatalIOError);
        }
    }

    return ctorPtr(p, iF, dict);
}


template<class Type>
Foam::tmp<Foam::fvPatchgpuField<Type>> Foam::fvPatchgpuField<Type>::New
(
    const fvPatchgpuField<Type>& ptf,
    const gpufvPatch& p,
    const DimensionedgpuField<Type, gpuvolMesh>& iF,
    const fvPatchgpuFieldMapper& pfMapper
)
{
    DebugInFunction
        << "Constructing fvPatchgpuField<Type>" << nl;

    auto* ctorPtr = patchMapperConstructorTable(ptf.type());

    if (!ctorPtr)
    {
        FatalErrorInLookup
        (
            "patchField",
            ptf.type(),
            *patchMapperConstructorTablePtr_
        ) << exit(FatalError);
    }

    return ctorPtr(ptf, p, iF, pfMapper);
}


// ************************************************************************* //
